"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var TruncateContext_1 = __importDefault(require("./TruncateContext"));
var TruncateItem_1 = __importDefault(require("./TruncateItem"));
function TruncateList(_a) {
    var children = _a.children, _b = _a.ellipsis, Ellipsis = _b === void 0 ? react_1.forwardRef(function (props, ref) { return react_1.default.createElement("div", __assign({ ref: ref }, props), "..."); }) : _b;
    var _c = react_1.default.useContext(TruncateContext_1.default), truncateIndex = _c.truncateIndex, observer = _c.observer, isTruncating = _c.isTruncating, done = _c.done;
    if (!isTruncating)
        return react_1.default.createElement(react_1.default.Fragment, null, children);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.Children.map(children, function (child, index) {
            return truncateIndex !== null ? (index < truncateIndex && child) : (react_1.default.createElement(TruncateItem_1.default, { id: index, observer: observer }, child));
        }),
        truncateIndex && Ellipsis && (react_1.default.createElement(react_1.default.Fragment, null, done ? (react_1.default.createElement(Ellipsis, { moreCount: react_1.default.Children.count(children) - truncateIndex, moreChildren: react_1.default.Children.toArray(children).slice(truncateIndex) })) : (react_1.default.createElement(TruncateItem_1.default, { id: "ellipsis-" + truncateIndex, observer: observer },
            react_1.default.createElement(Ellipsis, { moreCount: react_1.default.Children.count(children) - truncateIndex, moreChildren: react_1.default.Children.toArray(children).slice(truncateIndex) })))))));
}
exports.default = TruncateList;
