"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
function TruncateItem(_a) {
    var children = _a.children, id = _a.id, observer = _a.observer;
    var ref = react_1.useRef();
    react_1.useEffect(function () {
        var node = ref.current;
        if (node && observer) {
            observer.observe(node);
        }
        return function () {
            if (node && observer) {
                observer.unobserve(node);
            }
        };
    }, [id, observer]);
    var child = react_1.default.Children.only(children);
    return react_1.default.cloneElement(child, { ref: ref, 'data-observe-index': id });
}
exports.default = TruncateItem;
