import React from 'react';
declare type EllipsisProps = {
    moreCount: number;
    moreChildren: [React.ReactNode];
};
interface TruncateListProps {
    children: JSX.Element | JSX.Element[];
    ellipsis: EllipsisProps & React.ComponentPropsWithRef<any>;
}
export declare type TagProps = {
    children: React.ReactNode;
};
export declare type TagRef = HTMLDivElement;
declare function TruncateList({ children, ellipsis: Ellipsis, }: TruncateListProps): JSX.Element;
export default TruncateList;
